// Solution to Annoying Mosquitos
// Author: Thomas Beuman

// Time complexity: O(n*m)
// Memory: O(n)

// @EXPECTED_RESULTS@: CORRECT

// Solution method: check every combination of mosquito and swat

#include <cstdio>
#include <cstdlib>
#include <cstring>
using namespace std;

int X[100], Y[100];
bool Hit[100];

int main()
{ int cases, casenr, n, m, i, j, x, y, t;
  scanf("%d\n", &cases);
  for (casenr = 1; casenr <= cases; casenr++)
  { // Read input
    scanf("%d\n", &n);
    for (i = 0; i < n; i++)
      scanf("%d %d\n", &X[i], &Y[i]);
    scanf("%d\n", &m);
    // Check the vital signs of all mosquitos
    memset(Hit, false, sizeof(Hit));
    for (j = 0; j < m; j++)
    { scanf("%d %d\n", &x, &y);
      for (i = 0; i < n; i++)
        if (abs(X[i]-x) <= 50 && abs(Y[i]-y) <= 50)
          Hit[i] = true;
    }
    // Count the number of dead mosquitos
    t = 0;
    for (i = 0; i < n; i++)
      if (Hit[i])
        t++;
    printf("%d\n", t);
  }
  return 0;
}

