/*
 * @EXPECTED_RESULTS@: CORRECT
 */
import java.io.*;
import java.util.*;

public class jeroen2
{
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int tests = sc.nextInt();
		while (tests-- > 0)
		{
			int n = sc.nextInt();
			int m = sc.nextInt();
			Shop[] shops = new Shop[m];
			for (int i = 0; i < m; i++)
			{
				int si = sc.nextInt();
				int pi = sc.nextInt();
				int oi = sc.nextInt();
				shops[i] = new Shop(si, pi, oi);
			}
			Arrays.sort(shops);
			int[][] dp = new int[m + 1][n + 1];
			for (int i = 0; i <= m; i++)
				for (int j = 0; j <= n; j++)
					dp[i][j] = Integer.MAX_VALUE;
			dp[0][0] = 0;
			for (int i = 0; i < m; i++)
			{
				for (int j = 0; j <= n; j++)
				{
					if (dp[i][j] == Integer.MAX_VALUE) continue;
					dp[i + 1][j] = Math.min(dp[i + 1][j], dp[i][j]);
					int tobuy = Math.min(n - j, shops[i].s);
					dp[i + 1][j + tobuy] = Math.min(dp[i + 1][j + tobuy], dp[i][j] + tobuy * shops[i].p + shops[i].o);
				}
			}
			System.out.println(dp[m][n]);
		}
	}

	private static class Shop implements Comparable<Shop>
	{
		public int s, p, o;

		public Shop(int s, int p, int o)
		{
			this.s = s;
			this.p = p;
			this.o = o;
		}

		public int compareTo(Shop other)
		{
			return p - other.p;
		}
	}
}