/*
 * @EXPECTED_RESULTS@: CORRECT
 */
using System;

public class jeroen
{
	public static void Main(string[] args)
	{
		int N = int.Parse(Console.ReadLine());
		while(N-- > 0)
		{
			string[] parts = Console.ReadLine().Split(".(".ToCharArray());
			string nonrepeating = parts[1];
			string repeating = parts.Length > 2 ? parts[2].Substring(0, parts[2].Length - 1) : "";
			if(parts.Length > 2 && (Only(repeating,'0') || Only(repeating,'9')))
				throw new Exception("Repeating part should not consist of nines or zeros only");
			Frac ret = new Frac(0, 1);
			if(nonrepeating.Length > 0)
				ret += new Frac(long.Parse(nonrepeating), (long)Math.Pow(10, nonrepeating.Length));
			if(repeating.Length > 0)
			{
				Frac f2 = new Frac(long.Parse(repeating), (long)Math.Pow(10, repeating.Length) - 1);
				f2.b *= (long)Math.Pow(10, nonrepeating.Length);
				ret += f2;
			}
			Console.WriteLine(ret);
		}
	}

	public static bool Only(string s, char c)
	{
		foreach(char c2 in s)
			if(c2 != c)
				return false;
		return true;	
	}

	public static long GCD(long a, long b)
	{
		return b == 0 ? a : GCD(b, a % b);
	}

	public static long LCM(long a, long b)
	{
		return a / GCD(a,b) * b;
	}

	public class Frac
	{
		public long a, b;

		public Frac(long a, long b)
		{
			this.a = a; this.b = b;
		}

		public override string ToString()
		{
			return a + "/" + b;
		}

		public void Simplify()
		{
			long g = GCD(a, b);
			a /= g;
			b /= g;
		}

		public static Frac operator +(Frac f1, Frac f2)
		{
			long nd = LCM(f1.b, f2.b);
			Frac ret = new Frac(f1.a * (nd / f1.b) + f2.a * (nd / f2.b), nd);
			ret.Simplify();
			return ret;
		}
	}
}