/*
 * @EXPECTED_RESULTS@: CORRECT
 */
import java.io.*;
import java.util.*;

public class jeroen2
{
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int tests = sc.nextInt();
		while (tests-- > 0)
		{
			String[] parts = sc.next().split("[\\.\\(]");
			String nonrepeating = parts[1];
			String repeating = parts.length > 2 ? parts[2].substring(0, parts[2].length() - 1) : "";
			Frac ret = new Frac(0, 1);
			if(nonrepeating.length() > 0)
				ret = Frac.plus(ret, new Frac(Long.valueOf(nonrepeating), (long)Math.pow(10, nonrepeating.length())));
			if(repeating.length() > 0)
			{
				Frac f2 = new Frac(Long.valueOf(repeating), (long)Math.pow(10, repeating.length()) - 1);
				f2.b *= (long)Math.pow(10, nonrepeating.length());
				ret = Frac.plus(ret, f2);
			}
			System.out.println(ret);
		}
	}

	public static long GCD(long a, long b)
	{
		return b == 0 ? a : GCD(b, a % b);
	}

	public static long LCM(long a, long b)
	{
		return a / GCD(a,b) * b;
	}

	private static class Frac
	{
		public long a, b;

		public Frac(long a, long b)
		{
			this.a = a; this.b = b;
		}

		public String toString()
		{
			return a + "/" + b;
		}

		public void Simplify()
		{
			long g = GCD(a, b);
			a /= g;
			b /= g;
		}

		public static Frac plus(Frac f1, Frac f2)
		{
			long nd = LCM(f1.b, f2.b);
			Frac ret = new Frac(f1.a * (nd / f1.b) + f2.a * (nd / f2.b), nd);
			ret.Simplify();
			return ret;
		}
	}
}