/*
 * @EXPECTED_RESULTS@: CORRECT
 */

import java.io.*;
import java.util.*;

public class jeroen2
{
	public static int[] dr = { 0, 1, 1, 0, -1, -1 };
	public static int[] dc = { -1, 0, -1, 1, 0, 1 };
	public static int N;
	public static String[] grid;
	public static boolean[][] done;
	
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int tests = sc.nextInt();
		while (tests-- > 0)
		{
			N = sc.nextInt();
			grid = new String[N];
			for(int i = 0; i < N; i++)
				grid[i] = sc.next();

			// White wins?
			done = new boolean[N][N];
			for(int i = 0; i < N; i++)
				dfs(i, 0, 'W');
			boolean win = false;
			for(int i = 0; i < N; i++)
				if(done[i][N-1])
					win = true;
			if(win)
			{
				System.out.println("White wins");
				continue;
			}

			// Black wins?
			done = new boolean[N][N];
			for(int i = 0; i < N; i++)
				dfs(0, i, 'B');
			win = false;
			for(int i = 0; i < N; i++)
				if(done[N-1][i])
					win = true;
			if(win)
			{
				System.out.println("Black wins");
				continue;
			}

			System.out.println("Not finished");
		}
	}

	public static void dfs(int r, int c, char v)
	{
		if(r < 0 || r >= N || c < 0 || c >= N || done[r][c] || grid[r].charAt(c) != v) return;
		done[r][c] = true;
		for(int i = 0; i < 6; i++)
			dfs(r+dr[i], c+dc[i], v);
	}
}