/*
 * @EXPECTED_RESULTS@: CORRECT
 */

import java.io.*;
import java.util.*;

public class jeroen2
{
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int N = sc.nextInt();
		Dictionary<String,String> dict = new Hashtable<String,String>();
		String prev = "";
		for(int i = 0; i < N; i++)
		{
			String w = sc.next();
			String norm = NormalForm(w, (1<<w.length()) - 1);
			if(dict.get(norm) == null)
				dict.put(norm, w);
			prev = w;
		}
		int T = sc.nextInt();
		for(int i = 0; i < T; i++)
		{
			String letters = sc.next();
			String ans = "IMPOSSIBLE";
			for(int mask = 1; mask < (1<<letters.length()); mask++)
			{
				String norm = NormalForm(letters, mask);
				if (dict.get(norm) != null && (ans.equals("IMPOSSIBLE") || norm.length() > ans.length() || (norm.length() == ans.length() && dict.get(norm).compareTo(ans) < 0)))
					ans = dict.get(norm);
			}
			System.out.println(ans);
		}
	}

	public static String NormalForm(String s, int mask)
	{
		char[] ret = new char[NumBits(mask)];
		int i = 0;
		for(int j = 0; j < s.length(); j++)
			if((mask & (1<<j)) > 0)
				ret[i++] = s.charAt(j);
		Arrays.sort(ret);
		return new String(ret);
	}

	public static int NumBits(int i)
	{
		int res = 0;
		while(i > 0)
		{
			res += i & 1;
			i >>= 1;
		}
		return res;
	}
}